<template>
  <div class="card">
    <Circle v-if="!loaded" />
    <canvas id="roc_curve"></canvas>
  </div>
</template>

<script>
import Chart from "chart.js/auto";
import { Circle } from "vue-loading-spinner";

export default {
  name: "RocCurve",
  components: {
    Circle,
  },
  props: {
    fpr: Array,
    tpr: Array,
    tresholds: Array,
    auc: Number,
    loaded: Boolean,
    best_treshold: Number
  },
  watch: {
    tpr: function () {
      if (this.tpr.length > 0) {
        this.drawChart();
      }
    },
  },
  mounted: function () {
    if (this.tpr.length > 0) {
      this.drawChart();
    }
  },
  methods: {
    generateData: function () {
      var data = [];
      for (var i = 0; i < this.fpr.length; i++) {
        data.push({
          x: this.fpr[i],
          y: this.tpr[i],
        });
      }
      return data;
    },
    getBestTresholdRocPoint: function() {
      var index = this.tresholds.indexOf(this.best_treshold)
      return {
        x: this.fpr[index],
        y: this.tpr[index]
      }
    },
    drawChart: function () {
      const container = document.getElementById("roc_curve");

      const data = {
        labels: [
          "0",
          "0.1",
          "0.2",
          "0.3",
          "0.4",
          "0.5",
          "0.6",
          "0.7",
          "0.8",
          "0.9",
          "1",
        ],
        datasets: [
          {
            label: "Best Treshold",
            data: [this.getBestTresholdRocPoint()],
            backgroundColor: "rgb(255,175,0)",
             borderColor: "rgb(255,175,0)",
          },
          {
            label: "Zufall",
            data: [
              { x: 0, y: 0 },
              { x: 1, y: 1 },
            ],
            showLine: true,
            borderColor: "rgb(133,141,148)",
            backgroundColor: "rgb(133,141,148)",
            borderDash: [5, 5],
          },
          {
            label: "ROC Kurve",
            data: this.generateData(),
            showLine: true,
            borderColor: "rgb(0,128,153)",
            fill: false,
          },
          {
            label: "AUC",
            data: this.generateData(),
            showLine: true,
            borderColor: "rgb(218,232,235)",
            fill: {
              target: "origin",
              above: "rgb(218,232,235)",
            },
          },
        ],
      };

      var context = this;
      const footer = (tooltipItems) => {
        if (tooltipItems.length == 3) {
          return "Treshold: " + context.tresholds[tooltipItems[1].dataIndex];
        }
        return "Treshold: " + context.tresholds[tooltipItems[0].dataIndex];
      };
      const label = (context) => {
        if (context.dataset.label == "ROC Kurve") {
          return "FPR: " + context.label + " TPR: " + context.formattedValue;
        }
      };

      new Chart(container, {
        type: "scatter",
        data: data,
        options: {
          responsive: true,
          elements: {
            point: {
              radius: 2,
            },
          },
          plugins: {
            tooltip: {
              callbacks: {
                footer: footer,
                label: label
              },
            },
          },
          title: {
            display: true,
            text: "ROC Kurve",
          },
          scales: {
            x: {
              display: true,
              title: {
                display: true,
                text: "False-Positive-Rate",
              },
            },
            y: {
              display: true,
              title: {
                display: true,
                text: "Trupe-Positive-Rate",
              },
            },
          },
        },
      });
    },
  },
};
</script>

<style scoped>
#roc_curve {
  max-height: 700px;
  max-width: 100%;
  margin: 0;
  padding: 0;
  overflow: hidden;
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
  background: transparent;
}

div {
  position: relative;
  height: 700px;
  min-height: 700px;
}
</style>
